%% demo for Discriminative Marginalized Least-Squares Regression for Hyperspectral Image Classification
%--------------Brief description-------------------------------------------
%
% 
% This demo implements DMLSR destriping for HSI [1]
%
%
% More details in:
%
% [1] Y. Zhang, W. Li, H. Li, R. Tao and Q. Du, 
% "Discriminative Marginalized Least-Squares Regression for Hyperspectral Image Classification," 
% in IEEE Transactions on Geoscience and Remote Sensing. doi: 10.1109/TGRS.2019.2949082
%
% contact: liwei089@ieee.org (Wei Li),zyx829625@163.com (Yuxiang Zhang)
% 
clear all; close all; clc

load demo_small_dataset
        
opts.rho = 1.01;
opts.miu = 1e-8;
opts.lambda1 = 1e-3;
opts.lambda2 = 1e-2;
opts.knn = 4;
opts.maxIter = 500;
opts.nnClass = length(CTrain);

train_label = [];
for j = 1:length(CTrain) 
   train_label = [train_label;j*ones(CTrain(j),1)];
end
label = unique(train_label);
L = bsxfun(@eq, train_label, label');
L = double(L);

Train_Ma = DataTrain'; 
X = Train_Ma./repmat(sqrt(sum(Train_Ma.^2)),[size(Train_Ma,1) 1]);
Test_Ma  = DataTest';
Y  = Test_Ma./repmat(sqrt(sum(Test_Ma.^2)),[size(Test_Ma,1) 1]); 

[P,Q,E,b,obj] = DMLSR(X,L,train_label,opts);
Train_Maa = Q'* X;
Test_Maa  = Q'* Y;
class = knnclassify(real(Test_Maa'),real(Train_Maa'),train_label,1,'euclidean','nearest');
[confusion, accur] = confusion_matrix_wei(class, CTest);
